// -*- Mode: c++ -*-

#ifndef _itk_WithDescriber_h_
#define _itk_WithDescriber_h_
//////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <iomanip.h>

#include "itk/btype.h"

namespace Itk {

   class WithDescriber {
      public:
	 virtual void describe(ostream& ostr, 
			       const Bool detailp = True) const {
	    ostr << "#WithDescriber[" << Ptr(this) << "]" ;
	    if(detailp) ostr << endl ;
	 } ;
   } ;

   inline ostream& operator<<(ostream& ostr, const WithDescriber& dt) {
      dt.describe(ostr,False) ;
      return ostr ;
   } 

   inline ostream& operator<<(ostream& ostr, const WithDescriber* ptr) {
      return ostr << Ptr(ptr) ;
   } 

   inline void dbg(const WithDescriber & obj) {
      obj.describe(cerr) ;
   } ;

   inline void dbg(const WithDescriber * obj) {
      obj->describe(cerr) ;
   } ;
}

//////////////////////////////////////////////////////////////////////
#endif
