// -*- Mode:C++ -*-
//Header:
//File: sclient2.cc
//Title: Simple Client 2
//Author: NODA, Itsuki
//Date: 2001/03/31
//

//ModifyHistory:
// 2001/03/31: Start to create this file for soccer server manual
//EndModifyHistory:

//Usage:
//	% sclient2 [TEAMNAME [SERVERHOST [SERVERPORT]]]
// 
//EndUsage:



#include "SimplePlayer.h"

using namespace SClient ;
using namespace Itk ;

//======================================================================
// My Player

class MyPlayer : public SimplePlayer {
   public:
      virtual const char * _classname() const { return "MyPlayer";};

      //--------------------------------------------------
      // run loop (main loop)

      Bool run(char * shost, UInt sport, char * teamname) ;

} ;

//----------------------------------------------------------------------
// run loop (main loop)

Bool MyPlayer::run(char * shost, UInt sport, char * teamname) {

   //----------------------------------------
   // initialize socket connection and send init command

   init(shost,sport,teamname) ;
	 
   //----------------------------------------
   // move to random position

   Flt x = fltRand(-50,-1) ;
   Flt y = fltRand(-30,30) ;
   sendMove(x,y) ;

   //----------------------------------------
   // fork sensor thread

   forkSensor() ;

   //----------------------------------------
   // main loop

   while(True) {
      if        (!isBallSeenRecently(10)) {
	 //------------------------------
	 // if ball is not seen recently
	 // look around by (turn 60)

	 for(UInt i = 0 ; i < 6 ; i++) {
	    turn(60) ;
	 }
      } else if (kickable()) {
	 //------------------------------
	 // if ball is kickable
	 // kick it to the opponent goal

	 kickToAbs(100,goalpos()) ;

      } else {
	 //------------------------------
	 // otherwise, 
	 // turn to the ball and dash to it

	 turnToAbs(ballpos()) ;
	 dash(100) ;
      }
   } 
   return True ; // never reach here
}

      
//======================================================================
// Main

int main(int argc, char** argv) {

   char * shost = "localhost" ;
   UInt sport = 6000 ;
   char * teamname = "MyTeam" ;

   if(argc > 1) teamname = argv[1] ;
   if(argc > 2) shost = argv[2] ;
   if(argc > 3) sport = atoi(argv[3]) ;
   
   MyPlayer player ;
   player.run(shost,sport,teamname) ;
   return 0 ;
} ;
   

